libdots
=======

Copyright EPFL 2015

This repository contains the ``libdots`` library, a 2D localization library
based on Anoto® technology. It is used to localize a camera-equipped device on a
surface with a printed encoded pattern. It is written in pure c and has no
external library dependencies other than ``libc``.

![Screenshot of the test application](samples/webcam/screenshot.png)

It has been successfully compiled and tested on:
- the PIC32MZ1024ECG064 microcontroller, built with ``xc32`` v1.34.
- Ubuntu 14.04, 15.04, 15.10

If you use ``libdots`` for academic purposes, please cite this work using the
reference found in the file [CITATION](CITATION).

This library is released under the LGPLv3 free software license. However,
**please refer to the end of this document for a important, patent-related,
legal notice.**

Installation
------------

To build and install on a desktop:

```
mkdir build
cd build
cmake ..
make
make install
```

To use:

```c
#include<dots_localization.h>

//...

DotsPositionInfo* posInfo = NULL;
while(true){
    /* acquire image */
    posInfo = dotsLocalize(posInfo, imagePixels, imageHeight, imageWidth);
}
```

and link with ``-ldots``.


Testing
-------

A sample application that uses a regular webcam to localize is available under
[samples/](samples/). For specific information, refer to the README.md found in
this directory.

The sample application can be built from the root directory with:

```
mkdir build
cd build
cmake .. -DWITH_SAMPLES=ON
make
```

It can then be run from within the build directory.

Tools
-----

Tools to generate and overlay dot patterns are found under [tools/](tools/). For
specific information, refer to their README.md found in their respective
directories.

Legal notice
------------

The Anoto® technology is still patented in certain countries (in particular, in
the United States of America and the United Kingdom). Therefore, in these
countries, **you must license the Anoto® technology before using this
software**. The technology used in ``libdots`` is covered by these patents:
``EP1224606``, ``EP1222604``, ``EP1451767`` and ``EP1515265``.

